]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- stripping libpthread looks like a bad idea
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
19                 gettextize --copy --force --no-changelog; \
20         else \
21                 gettextize --copy --force --no-changelog --intl; \
22         fi; \
23         if [ ! -f po/Makevars ]; then \
24                 cp -f po/Makevars{.template,}; \
25         fi; \
26 }
27
28 %__glib_gettextize      glib-gettextize --copy --force
29 %__gnome_doc_common     gnome-doc-common --copy
30 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
31 %__gtkdocize            gtkdocize --copy
32 %__intltoolize          intltoolize --copy --force
33 %__libtoolize           libtoolize --copy --force
34
35 #       The number of cvs changelog entries kept when building package.
36 %_buildchangelogtruncate 20
37
38 %dependencytracking     %{nil}
39
40 #       Relations between package names that cause dependency loops
41 #       with legacy packages that cannot be fixed. Relations are
42 #       specified as
43 #               p>q
44 #       where package p has a Requires: on something that package q Provides:
45 #
46 # XXX   Note: that there cannot be any whitespace within the string "p>q",
47 #       and that both p and q are package names (i.e. no version/release).
48 %_dependency_whiteout   %{nil}
49
50 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
51         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
52         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
53
54 #-----------------------------------------------------------------
55 #
56 # (re)definition of %{rpm*flags} with %filterout_* support
57 # BuildRequires:        awk
58 # BuildRequires:        rpmbuild(macros) >= 1.315
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i = 1; i in I; i++) {      A=0;    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
116  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
117  %{?__cc:CC="%{__cc}" ; export CC ; } \
118  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
119  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
120         --host=%{_target_platform} \
121         --prefix=%{_prefix} \
122         --exec-prefix=%{_exec_prefix} \
123         --bindir=%{_bindir} \
124         --sbindir=%{_sbindir} \
125         --sysconfdir=%{_sysconfdir} \
126         --datadir=%{_datadir} \
127         --includedir=%{_includedir} \
128         --libdir=%{_libdir} \
129         --libexecdir=%{_libexecdir} \
130         --localstatedir=%{_localstatedir} \
131         --sharedstatedir=%{_sharedstatedir} \
132         --mandir=%{_mandir} \
133         --infodir=%{_infodir} \
134         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
135         %{dependencytracking} \
136 }
137
138 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
139 %__cmake        /usr/bin/cmake
140 %cmake { \
141 CC="%{__cc}" \
142 CXX="%{__cxx}" \
143 CFLAGS="%{rpmcflags}" \
144 CXXFLAGS="%{rpmcxxflags}" \
145 %{__cmake} \
146 }
147
148 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
149 %__scons        /usr/bin/scons
150 %scons { \
151 %{__scons} \
152         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
153         CFLAGS="${CFLAGS:-%rpmcflags}" \
154         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
155         FFLAGS="${FFLAGS:-%rpmcflags}" \
156         CPPFLAGS="${CPPFLAGS:-}" \
157         %{?__cc:CC="%{__cc}"} \
158         %{?__cxx:CXX="%{__cxx}"} \
159         libsuffix=%{_lib} \
160         prefix=%{_prefix} \
161 }
162
163 # waf. see waf.spec
164 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
165 %__waf  /usr/bin/waf
166 %waf { \
167 CC="%{__cc}" \
168 CXX="%{__cxx}" \
169 CPP="%{__cpp}" \
170 CFLAGS="%{rpmcflags}" \
171 CXXFLAGS="%{rpmcxxflags}" \
172 %{__waf} \
173 }
174
175 #----------------------------------------------------------------
176 %global configure_cache 0
177 %configure_cache_file   %{buildroot}.configure.cache
178
179 %configure {./configure \
180         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
181         CFLAGS="${CFLAGS:-%rpmcflags}" \
182         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
183         FFLAGS="${FFLAGS:-%rpmcflags}" \
184         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
185         CPPFLAGS="${CPPFLAGS:-}" \
186         %{?__cc:CC="%{__cc}"} \
187         %{?__cxx:CXX="%{__cxx}"} \
188         --host=%{_target_platform} \
189         --build=%{_target_platform} \
190         --prefix=%{_prefix} \
191         --exec-prefix=%{_exec_prefix} \
192         --bindir=%{_bindir} \
193         --sbindir=%{_sbindir} \
194         --sysconfdir=%{_sysconfdir} \
195         --datadir=%{_datadir} \
196         --includedir=%{_includedir} \
197         --libdir=%{_libdir} \
198         --libexecdir=%{_libexecdir} \
199         --localstatedir=%{_localstatedir} \
200         --sharedstatedir=%{_sharedstatedir} \
201         --mandir=%{_mandir} \
202         --infodir=%{_infodir} \
203         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
204         %{dependencytracking} \
205         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
206 }
207
208 # ------------------------------------------------------------------------
209 # Overloading of some basic macros
210 %prep \
211 %%prep\
212 export LC_ALL=C\
213 export LANG=C\
214 unset LINGUAS ||:\
215 unset LANGUAGE ||:\
216 unset LC_MESSAGES ||:\
217 unset DISPLAY ||:\
218 %{nil}
219
220 %build %%build\
221 export LC_ALL=C\
222 export LANG=C\
223 unset LINGUAS ||:\
224 unset LANGUAGE ||:\
225 unset LC_MESSAGES ||:\
226 unset DISPLAY ||:\
227 %{nil}
228
229 %install \
230 %if 0%{?_enable_debug_packages}\
231 %{?buildsubdir:%{debug_package}}\
232 %endif\
233 %%install\
234 export LC_ALL=C\
235 export LANG=C\
236 unset LINGUAS ||:\
237 unset LANGUAGE ||:\
238 unset LC_MESSAGES ||:\
239 unset DISPLAY ||:\
240 %{nil}
241
242 # Location of autoconf macros
243 %_aclocaldir    %(aclocal --print-ac-dir)
244
245 # Location of omf files
246 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
247
248 # Location of pkgconfig files
249 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
250
251 # Location of desktop files
252 %_desktopdir    /usr/share/applications
253 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
254
255 # Location of pixmaps for applnk/desktop files
256 %_pixmapsdir    /usr/share/pixmaps
257
258 # Location of themable icons for applnk/desktop files
259 %_iconsdir      /usr/share/icons
260
261 # Location of fonts directories
262 %_fontsdir      /usr/share/fonts
263
264 # Location of Gtk and associated libraries documentation
265 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
266
267 # Location of KDE documentation
268 %_kdedocdir     %{_defaultdocdir}/kde/HTML
269
270 # unsermake script
271 %__unsermake /usr/share/unsermake/unsermake
272
273 # Current date
274 %date           %(LC_ALL="C" date +"%a %b %d %Y")
275
276 # tmp directory
277 %tmpdir         %(echo "${TMPDIR:-/tmp}")
278
279 # Example files, programs, scripts...
280 %_examplesdir   /usr/src/examples
281
282 # Alternative kernel type/version
283 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
284
285 # The directory holding Linux kernel sources
286 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
287
288 # If non-empty "debug" macro defined, add "dbg" suffix to release number
289 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
290
291 # Requires name = version-release
292 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
293
294 %releq_kernel()         %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
295 %requires_releq_kernel(s:)      Requires%{-s:(%{-s*})}: %releq_kernel
296
297 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
298 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
299
300 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
301
302 # kernel version-release handling
303 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
304 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
305 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
306 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
307 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
308
309 # sgml macros
310 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
311 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
312 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
313 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
314 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
315 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
316 %docbook_sgmlcat_fix() { for l in \
317 '' \
318 '  -- default decl --' \
319 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
320 '  -- hacks for opensp --' \
321 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
322 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
323 '' \
324 ; do echo $l; done >> %1 \
325 }
326
327 # vim - "
328
329 # minimum file size needed for compressed documents.
330 # just smaller files than this get larger when compressed.
331 # some stats:
332 # - 0 byte file compressed was 25 bytes .gz
333 # - 39 byte file was compressed as 57
334 # - with test/test.spec@man 158 byte file was compressed also 158
335 %_min_compress_bytes    159
336
337 #-----------------------------------------------------------------
338 # find and gzip all files in %{_mandir} and %{infodir}
339 #
340 # Requires: xargs, find
341 #
342 #%no_install_post_compress_docs 1
343 %__spec_install_post_compress_docs { \
344 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
345         for i in /usr/share/man /usr/X11R6/man; do \
346                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
347                         echo "Compress man pages: $i"; \
348                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
349                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
350                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
351                 fi; \
352         done; \
353         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
354                 echo "Compress info pages: %{_infodir}"; \
355                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
356                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
357                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
358         fi; \
359 }; __spec_install_post_compress_docs } }
360
361 #-----------------------------------------------------------------
362 # Strip executable binaries and shared object files
363 #
364 # Requires: find, awk, strip, cut, xargs
365 #
366 #%no_install_post_strip 1
367 %__spec_install_post_strip {%{!?debug: \
368 %{!?no_install_post_strip:__spec_install_post_strip() { \
369 if [ -d "$RPM_BUILD_ROOT" ]; then \
370         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
371                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
372                 modulecount=$(echo -n "$modulelist" | wc -l); \
373                 if [ "$modulecount" -gt 0 ]; then \
374                         printf "Stripping %d kernel modules..."; \
375                         echo "$modulelist" | xargs -l512 chmod u+w; \
376                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
377                         echo "DONE"; \
378                 fi; \
379         fi; \
380         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*libpthread-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
381         # vim - " \
382         if [ -z "$filelist" ]; then \
383                 return; \
384         fi; \
385         filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
386         elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
387         elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
388         archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
389         if [ -n "$elfexelist" ]; then \
390                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
391                 chmod u+w $elfexelist; \
392                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
393                 echo "DONE"; \
394         fi; \
395         if [ -n "$elfsharedlist" ]; then \
396                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
397                 chmod u+w $elfsharedlist; \
398                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
399                 echo "DONE"; \
400         fi; \
401         if [ -n "$archiveslist" ]; then \
402                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
403                 chmod u+w $archiveslist; \
404                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
405                 echo "DONE"; \
406         fi; \
407 fi; }; __spec_install_post_strip } } }
408
409 #-----------------------------------------------------------------
410 # remove all RPATH from executable binaries and shared object files
411 #
412 # Requires: find, awk, cut, xargs, chrpath, uname
413 #
414 #%no_install_post_chrpath       1
415 %__spec_install_post_chrpath {%{!?debug: \
416 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
417 if [ -d "$RPM_BUILD_ROOT" ]; then \
418         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
419         if [ -n "$files" ]; then \
420                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
421         fi
422         #"
423         if [ -n "$objs" ]; then \
424                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
425                 echo "$objs" | \
426                 while read file; do \
427                         rpath= ; \
428                         chmod u+w "$file"; \
429                         for dir in `chrpath -l "$file" | \
430                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
431                                         case $dir in \
432                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
433                                                 echo "remove-rpath: $dir in $file"; \
434                                                 ;; \
435                                         * ) \
436                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
437                                                 else rpath="$rpath:$dir" ; fi ; \
438                                                 ;; \
439                                         esac ; \
440                         done ; \
441                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
442                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
443                 done; \
444         fi; \
445 fi; }; __spec_install_post_chrpath } } }
446
447 #-----------------------------------------------------------------
448 # Find and gzip all kernel modules
449 #
450 # Requires: find
451 #
452 #%no_install_post_compress_modules      1
453 %__spec_install_post_compress_modules { \
454 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
455         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
456                 echo "Compress kernel modules"; \
457                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
458                 echo "$q" | xargs -r %{__gzip} -9nf; \
459                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
460                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
461                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
462         fi; \
463 }; __spec_install_post_compress_modules } }
464
465 # Remove common Perl files we don't package
466 %__spec_install_post_perl_clean {\
467 %{!?no_install_post_perl_clean: \
468 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
469 } }
470
471 #-----------------------------------------------------------------
472 # Update GConf2 schemas
473 #
474 # Requires: GConf2
475 #
476 %gconf_schema_install() \
477         umask 022; \
478         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
479         %{nil}
480
481 %gconf_schema_uninstall() \
482 if [ $1 = 0 ]; then \
483         umask 022; \
484         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
485 fi \
486 %{nil}
487
488 #-----------------------------------------------------------------
489 # Update desktop MIME database
490 # requires: desktop-file-utils
491 #
492 %update_desktop_database_post() {{ \
493         umask 022; \
494         /usr/bin/update-desktop-database -q; \
495 }} \
496 %{nil}
497
498 %update_desktop_database_postun() {{ \
499 if [ $1 = 0 ]; then \
500         umask 022; \
501         /usr/bin/update-desktop-database -q; \
502 fi \
503 }} \
504 %{nil}
505
506 #-----------------------------------------------------------------
507 # Update shared MIME info database
508 # requires: shared-mime-info
509 #
510 %update_mime_database() {{ \
511         umask 022; \
512         /usr/bin/update-mime-database %{_datadir}/mime; \
513 }} \
514 %{nil}
515
516 #-----------------------------------------------------------------
517 # Update icon cache
518 # requires: gtk+
519 #
520 %update_icon_cache() {{ \
521         umask 022; \
522         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
523 }} \
524 %{nil}
525
526 #-----------------------------------------------------------------
527 # Update scrollkeeper database
528 # requires: scrollkeeper
529 #
530 %scrollkeeper_update_post() \
531         /usr/bin/scrollkeeper-update -q; \
532         %{nil}
533
534 %scrollkeeper_update_postun() \
535 if [ $1 = 0 ]; then \
536         /usr/bin/scrollkeeper-update -q; \
537 fi \
538 %{nil}
539
540 #-----------------------------------------------------------------
541 # post %install sequence:
542 # - autodeps exceptions
543 # - compress all man and info pages,
544 # - strip all ELF executables and ELF shared objects if not %debug.
545 # - compress kernel modules if any
546
547 ###################################################################
548 # Requires/Provides automation
549 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
550 #
551 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
552 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
553 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
554 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
555 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
556 #%_noautocompressdoc    %{nil}
557 #
558 %_missing_doc_files_terminate_build     1%{nil}
559 %_unpackaged_files_terminate_build      %{nil}
560 # (X)emacs support
561 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
562 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
563 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
564
565 %__php_provides %{nil}
566 %__php_requires %{nil}
567 %__perl_provides %{nil}
568 %__perl_requires %{nil}
569 %__mono_provides %{nil}
570 %__mono_requires %{nil}
571
572 # Perl specific macro definitions.
573 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
574 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
575 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
576 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
577 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
578 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
579
580 # Ruby
581 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
582 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
583 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
584 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
585 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
586 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
587 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
588 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
589
590 %php_pear_dir           /usr/share/pear
591 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
592 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
593 %php_includedir         %(php-config --include-dir 2>/dev/null || echo ERROR)
594
595 # extract php/zend api versions
596 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
597 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
598 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
599 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
600 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
601 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
602 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
603
604 # helper macro
605 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
606
607 # macros for public use
608 # for php extensions (php-pecl)
609 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
610 %{__php_api_requires zend_module_api} \
611 %{__php_api_requires -v %php_major_version debug php_debug} \
612 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
613
614 # for zend extensions
615 %requires_zend_extension %{__php_api_requires zend_module_api} \
616 %{__php_api_requires zend_extension_api} \
617 %{__php_api_requires -v %php_major_version debug php_debug} \
618 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
619
620 # for php pdo modules (php-pecl-PDO_*)
621 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
622
623 # for using PHP post scripts. for PHP >= 5.0
624 %php_webserver_restart \
625 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
626 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
627 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
628         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
629         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
630                 %service -q php-fcgi restart \
631         fi \
632 fi \
633 %{nil}
634
635 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
636 %php4_webserver_restart \
637 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
638 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
639 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
640         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
641         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
642                 %service -q php-fcgi restart \
643         fi \
644 fi \
645 %{nil}
646
647
648 # X.org helper macros
649 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
650 #
651 %xorg_xserver_ansic_abi         %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
652 %xorg_xserver_extension_abi     %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
653 %xorg_xserver_font_abi          %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
654 %xorg_xserver_videodrv_abi      %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
655 %xorg_xserver_xinput_abi        %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
656
657 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
658 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
659 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
660 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
661 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
662 %{__xorg_abi_requires font xorg_xserver_font_abi}
663 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
664 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
665
666 # Python specific macro definitions.
667 # python main version
668 %py_ver                 %(python -c "import sys; print sys.version[:3]")
669
670 # directories
671 %py_prefix              %(python -c "import sys; print sys.prefix")
672 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
673 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
674 %py_incdir              /usr/include/python%{py_ver}
675 %py_sitedir             %{py_libdir}/site-packages
676 %py_sitescriptdir %{py_scriptdir}/site-packages
677 %py_dyndir              %{py_libdir}/lib-dynload
678
679 # pure python modules compilation
680 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
681
682 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
683
684 # Software written in Python language require Python with main version
685 %pyrequires_eq() Requires:      %1
686
687 # Hardlink binary identical .pyc and .pyo files
688 # (idea by glen <at> pld-linux <dot> org)
689 %__spec_install_post_py_hardlink {\
690 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
691 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
692         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
693         if cmp -s "$a" "$b"; then \
694                 ln -f "$a" "$b"; \
695         fi; \
696 done \
697 }; __spec_install_post_py_hardlink } }
698
699 # remove python sources, so that check-files won't complain
700 # (idea by glen <at> pld-linux <dot> org)
701 %py_postclean() \
702 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
703  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
704 done \
705 %{nil}
706
707 # depmod macro
708 %depmod() { \
709 umask 022; \
710 if [ -e /boot/System.map-%1 ]; then \
711         /sbin/depmod -a -F /boot/System.map-%1 %1; \
712 else \
713         if [ -e /boot/System.map ]; then \
714                 /sbin/depmod -a -F /boot/System.map %1; \
715         else \
716                 /sbin/depmod -a %1; \
717         fi \
718 fi; \
719 }
720
721 # XMMS specific macros
722 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
723 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
724 %xmms_version                   %(xmms-config --version 2>/dev/null)
725 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
726 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
727 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
728 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
729 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
730 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
731 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
732
733 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
734
735 # user/group checking macros
736 #
737 # Usage:
738 #       %userremove myuser
739 #
740 %userremove     /usr/lib/rpm/user_group.sh user del
741 %groupremove    /usr/lib/rpm/user_group.sh group del
742 #
743 # Usage:
744 #       if %usertestrm myuser; then
745 #               /usr/sbin/userdel -r myuser
746 # Note:
747 #       use these macros only if you need to call userdel/groupdel with
748 #       a non-standard option or take an extra action; otherwise use the
749 #       %userremove/%groupremove macros
750 #
751 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
752 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
753 # user group membership management macros
754 #
755 # Usage:
756 #       %addusertogroup myuser agroup
757 #
758 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
759
760 # banner support (useful in {pre,post}{,un} and triggers)
761 #
762 # Usage:
763 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
764 # the banner text, the banner text
765 # the banner text, and following line
766 #EOF
767 # You can use any form of here-document, <<'EOF' <<-EOT will do.
768 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
769 #
770 # -a   - append to the banner
771 # -e   - send to stderr instead of stdout
772 # -n   - no show banner (overrides -t)
773 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
774 %banner(aent:)  \
775 RPM_SCRIPTVERBOSITY=5 \
776 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
777 if [ -x /usr/bin/banner.sh ]; then \
778         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
779 else \
780         CMD="cat%{-e: >&2}" \
781 fi \
782 eval $CMD %2%{?3: %3} \
783 %nil
784
785 # useradd/groupadd macros
786 # Author: Elan Ruusamäe <glen@pld-linux.org>
787 #
788 # Usage:
789 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
790 #   [-g initial_group] [-G group[,...]] login
791 #
792 #  -u uid. REQUIRED
793 #  -g gid/group. REQUIRED
794 #  -s defaults to /bin/false
795 #  -d defaults to /usr/share/empty
796 #  -c No default
797 #  -r is accepted but ignored (it's always set)
798 #  -k skeleton dir. defaults to /usr/share/empty
799 # rpm specific flags
800 #  -P package name. defaults to %{name}
801 #
802 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
803 %{!-u:%{error:useradd: Required argument -u missing}} \
804 %{!-g:%{error:useradd: Required argument -g missing}} \
805 %{!?1:%{error:useradd: Required parameter login missing}} \
806 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
807         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
808                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
809                 exit 1 \
810         fi \
811 else \
812         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
813         /usr/sbin/useradd \\\
814                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
815                 -u %{-u*} \\\
816                 -r \\\
817                 -d %{-d*}%{!-d:/usr/share/empty} \\\
818                 -s %{-s*}%{!-s:/bin/false} \\\
819                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
820                 -g %{-g*} \\\
821                 %{-M} \\\
822                 %{-G:-G %{-G*}} \\\
823                 %{expand:%{%{#}}} 1>&2 || exit $? \
824         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
825 fi;
826
827 # Usage:
828 #   %groupadd [-P package] [-g gid] group
829 #
830 # -g gid. REQUIRED
831 #
832 # Sample:
833 #   %groupadd -P %{name}-base -g %{gid} %{name}
834
835 %groupadd(g:P:rfo)      \
836 %{!-g:%{error:groupadd: Required argument -g missing}} \
837 %{!?1:%{error:groupadd: Required parameter group missing}} \
838 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
839         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
840                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
841                 exit 1 \
842         fi \
843 else \
844         echo "Adding group %{1} GID=%{-g*}." \
845         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
846         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
847 fi;
848
849 # apache_config_{install/uninstall} macros *DEPRECATED*
850 # Author: Elan Ruusamäe <glen@pld-linux.org>
851 #
852 # You should use webapp macros instead. these are here until single piece of
853 # them is gone from specs ;)
854 #
855 # The config is installed/removed inside trigger, this means that you can any
856 # time install apache1 or apache package and the configuration file is updated.
857 # if you don't need the config for various reason for specific apache, just
858 # remove the symlink from apache config directory. the trigger will not put the
859 # config again to that version of apache. In other words the config is linked
860 # to apache config directory on first install of PACKAGE or apache.
861 #
862 # should be called in trigger body:
863 #  %triggerin -- apache1 >= 1.3.33-2
864 #  %apache_config_install -v 1
865 #
866 # Add package's apache config to apache config.
867 #
868 # Usage:
869 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
870 #
871 #  -v REQUIRED: specify apache version. can be 1 or 2.
872 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
873 #  -n OPTIONAL: specify config "slot". defaults to 99
874 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
875 #
876 # Internal macros. don't use ;).
877 # expands apache config dir by apache version at build time.
878 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
879 # expands apache service name by apache version at build time.
880 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
881
882 %apache_config_install(fv:c:n:) \
883 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
884 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
885 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
886         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
887 fi\
888 # reload apache if the config symlink is there\
889 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
890         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
891         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
892                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
893         fi\
894 fi\
895 %{nil}
896
897 # Remove package's apache config from apache config.
898 #
899 # Usage:
900 #   %apache_config_uninstall -v {1|2} -n 99
901 #
902 #  -v REQUIRED: specify apache version. can be 1 or 2.
903 #  -n OPTIONAL: specify config "slot". defaults to 99
904 %apache_config_uninstall(v:n:) \
905 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
906 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
907 # remove link if either of the packages are gone \
908 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
909         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
910                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
911                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
912                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
913                 fi \
914         fi \
915 fi \
916 %{nil}
917
918 # webapp macros
919 # Author: Elan Ruusamäe <glen@pld-linux.org>
920 #
921 # The config is installed/removed inside trigger, this means that you can any
922 # time install apache1/apache/lighttpd package and the configuration file is
923 # updated. if you don't need the config for various reason for specific
924 # webserver, just remove the symlink from config directory using webapp
925 # program. the trigger will not recreate the symlink on upgrades. In other
926 # words the config is linked to webserver config directory on first install of
927 # PACKAGE or WEBSERVER.
928 #
929 # Add package's webserver config to webserver webapps dir.
930 # Usage:
931 #   %webapp_register WEBSERVER WEBAPP
932 #
933 %webapp_register() \
934 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
935 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
936         /usr/sbin/webapp register %1 %2\
937 fi\
938 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
939 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
940         %{expand:%service -q %%1 reload}\
941 fi\
942 %{nil}
943
944 # Remove package's config from webserver webapps dir.
945 # Usage:
946 #   %webapp_register [-f] WEBSERVER WEBAPP
947 %webapp_unregister(f) \
948 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
949 # remove link if either of the packages are gone \
950 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
951         /usr/sbin/webapp unregister %1 %2\
952         %{expand:%service -q %%1 reload}\
953 fi \
954 %{nil}
955
956 # see browser-plugins.spec / template-browser-plugin.spec
957 # Author: Elan Ruusamäe <glen@pld-linux.org>
958 %nsplugin_install(d:f) { \
959 # create link if it's first install of either of the packages \
960 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
961 ( \
962 %( \
963         for file in %{*}; do \
964                 echo echo Installing $file to %{-d*}; \
965                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
966         done ) \
967 ) | ( %banner -t 5 -e %{name}-in ); fi; \
968 }
969
970 %nsplugin_uninstall(d:) { \
971 # remove link if either of the packages are gone \
972 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
973 ( \
974 %( \
975         for file in %{*}; do \
976                 echo echo Removing $file from %{-d*}; \
977                 echo "rm -f %{-d*}/$file;"; \
978         done ) \
979 ) | ( %banner -t 5 -e %{name}-un ); fi; \
980 }
981
982 # service macro.
983 # Author: Elan Ruusamäe <glen@pld-linux.org>
984 #
985 # calls usual service restart on package %post, but skips the restart if
986 # administrator has disabled automatic service restarts in either global
987 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
988 #
989 # Usage:
990 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
991 #
992 #  -q be silent when service isn't started (for scriplets restaring other package's services)
993 #
994 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
995
996
997 # Java macros. based on jpackage macros.java
998 #
999 # Root directory where all Java VMs/SDK/JREs are installed.
1000 %_jvmdir                %{_libdir}/jvm
1001
1002 # Root directory where all Java VMs/SDK/JREs expose their jars
1003 %_jvmjardir             %{_libdir}/jvm-exports
1004
1005 # Root directory for all Java VM/SDK/JRE's private things.
1006 %_jvmprivdir    %{_libdir}/jvm-private
1007
1008 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1009 %_jvmlibdir             %{_libdir}/jvm
1010
1011 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
1012 %_jvmdatadir    %{_datadir}/jvm
1013
1014 # Root directory for all configurations parts of Java VM/SDK/JRE's
1015 %_jvmsysconfdir %{_sysconfdir}/jvm
1016
1017 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1018 %_jvmcommonlibdir       %{_libdir}/jvm-common
1019
1020 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1021 %_jvmcommondatadir      %{_datadir}/jvm-common
1022
1023 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1024 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1025
1026 # Directory where arch-specific (JNI) version-independent jars are installed.
1027 %_jnidir                %{_libdir}/java
1028
1029
1030 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
1031
1032 %ant                    JAVA_HOME=%{java_home} ant
1033 %jar                    %{java_home}/bin/jar
1034 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
1035 %javac                  %{java_home}/bin/javac
1036 %javadoc                %{java_home}/bin/javadoc
1037
1038 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1039
1040 %jpackage_script() \
1041 install -d $RPM_BUILD_ROOT%{_bindir}\
1042 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1043 #!/bin/sh\
1044 #\
1045 # %{name} script\
1046 # JPackage Project <http://www.jpackage.org/>\
1047 \
1048 # Source functions library\
1049 . %{_javadir}-utils/java-functions\
1050 \
1051 # Source system prefs\
1052 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1053     . %{_sysconfdir}/java/%{name}.conf\
1054 fi\
1055 \
1056 # Source user prefs\
1057 if [ -f $HOME/.%{name}rc ]; then\
1058     . $HOME/.%{name}rc\
1059 fi\
1060 \
1061 # Configuration\
1062 MAIN_CLASS=%1\
1063 BASE_FLAGS=%2\
1064 BASE_OPTIONS=%3\
1065 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1066 \
1067 # Set parameters\
1068 set_jvm\
1069 set_classpath $BASE_JARS\
1070 set_flags $BASE_FLAGS\
1071 set_options $BASE_OPTIONS\
1072 \
1073 # Let's start\
1074 run "$@"\
1075 EOF
1076
1077 # PEAR install macros
1078 # Author: Elan Ruusamäe <glen@pld-linux.org>
1079 #
1080 # Usage:
1081 #       %%pear_package_setup [-a #] [-n FMT]
1082 #
1083 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1084 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1085 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1086 #
1087 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1088 # destination hierarchy. you should copy the tree to buildroot after
1089 # patching/reorganizing with %%pear_package_install.
1090 #
1091 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1092 # line endings.
1093 #
1094 # the pear install process output is recorded to install.log, you should put it
1095 # to %%doc for later debug or just for information.
1096 #
1097 # additionally additional-packages.txt is produced if it was detected that the
1098 # package has optional dependencies. the file format is suitable of displaying
1099 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1100 # automatically added for this file.
1101
1102
1103 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1104 %__pear_install_log \
1105 tee install.log \
1106 # make post message of optional packages \
1107 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1108 if [ -s optional-packages.txt ]; then \
1109         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1110 else \
1111         rm -f optional-packages.txt \
1112 fi \
1113 %{nil}
1114
1115 # command invoking pear cli
1116 %__pear /usr/bin/pear
1117
1118 %pear_install(a:n:zD) \
1119 %__pear \\\
1120         -c pearrc \\\
1121         -d doc_dir=/docs \\\
1122         -d php_dir=%{php_pear_dir} \\\
1123         -d bin_dir=%{_bindir} \\\
1124         -d data_dir=%{php_pear_dir}/data \\\
1125         -d test_dir=%{php_pear_dir}/tests \\\
1126         install \\\
1127         --packagingroot=%{builddir} \\\
1128         --offline \\\
1129         --nodeps \\\
1130         %{-f:--force} \\\
1131         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1132 %{nil}
1133
1134 # The main macro.
1135 # using this macro will append optional-packages.txt to the nocompressdoc list
1136 # as it's displayed to user after package install. and adding additional gzip
1137 # dep is just waste ;)
1138 %pear_package_setup(a:n:zD) \
1139 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1140 %define builddir %{_builddir}/%{srcdir} \
1141 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1142 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1143 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1144 %pear_install \
1145 %{-z:cd ..} \
1146 cat %{-z:$_N/}.install.log | %__pear_install_log \
1147 \
1148 # undos sources \
1149 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1150 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1151 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1152 %{nil}
1153
1154 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1155 # Author: Elan Ruusamäe <glen@pld-linux.org>
1156 %pear_package_install() \
1157 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1158 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1159 # help the developer out a little: \
1160 if [ -f _noautoreq ]; then \
1161         echo "AutoReqdep detected:" \
1162         echo "_noautoreq $(cat _noautoreq)" \
1163 fi \
1164 %{nil}
1165
1166
1167 # Register OpenLDAP schema.
1168 # Author: Elan Ruusamäe <glen@pld-linux.org>
1169 #
1170 # Usage:
1171 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1172 #
1173 #  -d specify dependant schemas, separated by comma
1174 #
1175 %openldap_schema_register(d:) \
1176 for schema in %*; do \
1177         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1178                 %{__sed} -i -e " \
1179                         /^include.*local.schema/{ \
1180                                 iinclude\\t     $schema\
1181                         } \
1182                 " /etc/openldap/slapd.conf \
1183         fi \
1184 done \
1185 # enable dependant schemas \
1186 if [ "%{-d*}" ]; then \
1187         %{__sed} -i -e ' \
1188         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1189                 s/^#// \
1190         }' /etc/openldap/slapd.conf \
1191 fi \
1192 %{nil}
1193
1194 # Unregister OpenLDAP schema.
1195 # Author: Elan Ruusamäe <glen@pld-linux.org>
1196 #
1197 # Usage:
1198 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1199 #
1200 %openldap_schema_unregister() \
1201 for schema in %*; do \
1202         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1203                 %{__sed} -i -e " \
1204                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1205                 # for symmetry it would be nice if we disable enabled schemas in post, \
1206                 # but we really can not do that, it would break something else. \
1207                 " /etc/openldap/slapd.conf \
1208         fi \
1209 done \
1210 %{nil}
1211
1212 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1213
1214
1215 # Build modules for kernels 2.6
1216 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1217 #
1218 # Usage:
1219 #       %build_kernel_modules -m <modules> -C <directory>
1220 #
1221 #  remember that proper Makefile is still required
1222 # Options:
1223 #  -m <modules> (required) -- comma-separated list of modules to save,
1224 #               without .ko extension, may be placed in subdirectory
1225 #  -C <directory> -- change to <directory> before doing anything
1226 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1227 #  -c -- do not execute make clean
1228 #  <additional arguments> -- all additional arguments will be passed to
1229 #               make modules
1230 #
1231 # Additional patching supported via here document. Try:
1232 #       %build_kernel_modules -m module <<'EOF'
1233 #       your patch script here
1234 #       EOF
1235 # Don't use it unless patching depends on config options.
1236
1237 # Developer note: don't touch it unless you know how to handle '\'.
1238 # - \ in script expands to nothing
1239 # - \\\ in script expands to \
1240 # - \\\ inside definition expands to nothing
1241 # - \\\\\\\ inside definition expands to \
1242 # - in last line \ has to touch arguments so arguments passing
1243 #   in new lines (using \) will be supported
1244
1245 %build_kernel_modules(p:P:m:C:c)                                                                        \
1246 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1247                                                                                                                                         \
1248 %define Opts                                                                                                            \\\\\\\
1249 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1250         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1251         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1252         %else                                                                                                                   \\\
1253         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1254         %endif                                                                                                                  \\\
1255 %else                                                                                                                           \\\
1256         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1257 %endif                                                                                                                          \
1258 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1259                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1260                                                                                                                                         \
1261 %{?-C:cd %{-C*}}                                                                                                        \
1262 compile() {                                                                                                                     \
1263         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1264         set -e -x                                                                                                               \
1265                                                                                                                                         \
1266 for cfg in %{?with_dist_kernel:dist}%{!?with_dist_kernel:nondist}; do \
1267         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1268                                                                                                                                         \
1269         rm -rf o                                                                                                                \
1270         install -d o/include/linux                                                                              \
1271         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1272         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1273         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1274 %ifarch ppc ppc64                                                                                                       \
1275         install -d o/include/asm                                                                                \
1276         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1277         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -snf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm   \
1278 %else                                                                                                                           \
1279         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1280 %endif                                                                                                                          \
1281                                                                                                                                         \
1282         set +x                                                                                                                  \
1283         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1284         set -x                                                                                                                  \
1285                                                                                                                                         \
1286         %if %{with dist_kernel}                                                                                 \
1287                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1288                         %{-p*} %{-P*}                                                                                   \\\
1289                         %{MakeOpts}                                                                                             \
1290         %else                                                                                                                   \
1291                 install -d o/include/config                                                                     \
1292                 touch o/include/config/MARKER                                                           \
1293                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1294         %endif                                                                                                                  \
1295                                                                                                                                         \
1296         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1297                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1298                 M=$PWD %{MakeOpts}}                                                                                     \
1299         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1300                 ${1+"$@"}                                                                                                       \\\
1301                 M=$PWD %{MakeOpts}                                                                                      \
1302                                                                                                                                         \
1303         for MODULE in {%{-m*},}; do                                                                             \
1304                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1305         done                                                                                                                    \
1306 done                                                                                                                            \
1307 %{?-C:cd -}                                                                                                                     \
1308 }                                                                                                                                       \
1309 compile %{*}\
1310 %{nil}
1311
1312
1313 # Install kernel modules built by %build_kernel_modules
1314 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1315 #
1316 # Usage:
1317 #       %install_kernel_modules -m <modules> -d <directory>
1318 #
1319 # Options:
1320 #  -m <modules> (required) -- comma-separated list of modules to install,
1321 #               without .ko extension, may be placed in subdirectory
1322 #  -d <directory> (required) -- in what subdirectory modules should be
1323 #               installed (eg. misc, kernel/drivers/net)
1324 #  -s <suffix> -- suffix to use when installing modules, useful when module
1325 #               with same name exists in kernel already
1326 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1327 #               for definig aliases, only useful with -s
1328
1329 %install_kernel_modules(m:d:s:n:)                                                                       \
1330 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1331 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1332 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1333                                                                                                                                         \
1334 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1335 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1336                                                                                                                                         \
1337 install -d %{KernelD}/%{-d*}                                                                    \
1338 %{?-s:install -d %{ModprobeD}}                                                          \
1339                                                                                                                                         \
1340 for MODULE in {%{-m*},}; do                                                                                     \
1341         [ -n "${MODULE}" ] || continue                                                                  \
1342         MNAME=${MODULE##*/}                                                                                             \
1343         %if %{without dist_kernel}                                                                              \
1344                 install ${MODULE}-nondist.ko                                                            \\\
1345                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1346                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1347                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1348         %else                                                                                                                   \
1349                 install ${MODULE}-dist.ko                                                                               \\\
1350                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1351                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1352                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1353         %endif                                                                                                                  \
1354 done                                                                                                                            \
1355 %{nil}
1356
1357 # patchset macros
1358 # Author: Elan Ruusamäe <glen@pld-linux.org>
1359 #
1360 # Usage:
1361 #   %patchset_source -f <seq(1) format> <start> [<end>]
1362 #   %patchset_patch <start> [<end>]
1363 #
1364 # If <end> is omited, it is assumed to be <start>.
1365 #
1366 # For example in preamble:
1367 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1368 # and in %prep:
1369 #  %patchset_patch 33 44
1370
1371 # generate SourceX urls from range START STOP
1372 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1373 # The sources start from 10000
1374 %patchset_source(f:b:) %(
1375         base=%{-b*}%{!-b*:10000};
1376         start=$(expr $base + %1);
1377         end=$(expr $base + %{?2}%{!?2:%{1}});
1378         # we need to call seq twice as it doesn't allow two formats
1379         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1380         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1381         paste %{tmpdir}/__ps{1,2};
1382         rm -f %{tmpdir}/__ps{1,2};
1383 ) \
1384 %{nil}
1385
1386 # apply sources from %patchset_source
1387 # -p specify -pX for %patch line
1388 # -b base offset: defaults to 10000
1389 %patchset_patch(f:p:b:) %(
1390         base=%{-b*}%{!-b*:10000};
1391         start=$(expr $base + %1);
1392         end=$(expr $base + %{?2}%{!?2:%{1}});
1393         echo ": patchset_patch %1%{?2: to %2}";
1394         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1395 ) \
1396 %{nil}
1397
1398 # browser plugins v2
1399 # Author: Elan Ruusamäe <glen@pld-linux.org>
1400 #
1401 # Usage:
1402 #       %browser_plugins_add_browser <name> -p <plugindir>
1403 #
1404 #  <name> (required) -- name of the browser. usually %{name}.
1405 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1406 #  -b -- default blacklists
1407 #  -a <arch> override arch
1408 #
1409 # Example:
1410 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1411
1412 %_browserpluginsconfdir         /etc/browser-plugins
1413 %_browserpluginsdir                     %{_libdir}/browser-plugins
1414 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1415
1416 %browser_plugins_add_browser(p:b:a:) \
1417         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1418         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1419         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1420         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1421         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1422         %{-b:cat >> $blacklist_file %{-b*}} \
1423 %{nil}
1424
1425 # vim:ts=4 sw=4 noet syn=spec
This page took 0.279936 seconds and 4 git commands to generate.